#include <bits/stdc++.h>
using namespace std;


vector <int> v;
vector <pair <int, int>> moves;

void make_move(int a, int b){
    moves.push_back(make_pair(a, b));
}

int cntI(int l, int r){
    int s = 0;
    for(int i = l; i <= r; i++){
        for(int j = i+1; j <= r; j++){
            if(v[i] > v[j])
                s++;
        }
    }
    return s;
}

void reverse(int l, int r){
    for(int i = 0; i < (l+r-1)/2; i++){
        swap(v[l + i], v[r - i]);
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n;
	cin>>n;
    for(int i = 0; i < n; i++){
        int a;
        cin >> a;
        v.push_back(a);
    }

    bool b = 1;
    while(b){
        b = 0;
        for(int i = 0; i < n; i++){
            for(int j = i + 1; j < n; j++){
                if(v[j] < v[i]){
                    swap(v[j], v[i]);
                    b = 1;
                    make_move(i, j);
                }
            }
        }
    }

    cout << moves.size();
    for(auto i : moves){
        cout << i.first << ' ' << i.second << '\n';
    }
}
